boss = false

function boss_load()
	bo = {}
	bo.x = mapW/2
	bo.y = mapH/2
	bo.w = 200
	bo.h = 200
	bo.angle = 0
	bo.timer = 1
	bo.health = 1000
	bo.rippled = false
	bo.tx = 0
	bo.ty = 0
end
killtimer = 0
killno = 0
function boss_update(dt)
	if(bo.health >= 800) then
		bo.timer = bo.timer - 1 * dt
		bo.angle = bo.angle + 1 * dt
		if(bo.timer <= 0) then
			for i=-10,10 do
				b = {}
				b.x = bo.x
				b.y = bo.y
				b.angle = bo.angle
				b.dx = math.cos(bo.angle + (0.2 * i)) * 30
				b.dy = math.sin(bo.angle + (0.2 * i)) * 30
				table.insert(eBullets,b)		
			end
			bo.timer = 1
		end
	elseif(bo.health >= 700) then
		bo.timer = bo.timer - 1 * dt
		if(bo.timer <= 0) then
			spawnE(2)
			bo.timer = 0.5
		end
	elseif(bo.health >= 500) then
		bo.timer = bo.timer - 1 * dt
		bo.angle = math.atan2((player.y - bo.y),(player.x - bo.x))
		dx = math.cos(bo.angle) * 10
		dy = math.sin(bo.angle) * 10		
		if(bo.timer <= 0) then
			
		
			for i=-2,2 do
				b = {}
				b.x = bo.x
				b.y = bo.y
				b.angle = bo.angle
				b.dx = math.cos(b.angle + (0.2 * i)) * 30
				b.dy = math.sin(b.angle + (0.2 * i)) * 30
				table.insert(eBullets,b)
			end
			
			bo.timer = 1
		end
		bo.x = bo.x + dx * dt
		bo.y = bo.y + dy * dt
	elseif(bo.health >= 300) then
		bo.timer = bo.timer - 1 * dt
		if(bo.timer <= 0) then
			spawnE2(2)
			bo.timer = 1
		end
	elseif(bo.health >= 200) then
		bo.timer = bo.timer - 1 * dt
		bo.angle = bo.angle + 1 * dt
		if(bo.timer <= 0) then
			for i=-10,10 do
				b = {}
				b.x = bo.x
				b.y = bo.y
				b.angle = bo.angle
				b.dx = math.cos(bo.angle + (0.2 * i)) * 30
				b.dy = math.sin(bo.angle + (0.2 * i)) * 30
				table.insert(eBullets,b)		
			end
			bo.timer = 1
		end	
	elseif(bo.health >= 100)then
		bo.timer = bo.timer - 1 * dt
		if(bo.timer <= 0 and bo.rippled == false) then
			bo.tx = math.random(10,mapW-10)
			bo.ty = math.random(10,mapH-10)
			
			bo.rippled = true
			r = {}
			r.r = 1
			r.x = bo.tx
			r.y = bo.ty
			table.insert(eripples,r)
			r = {}
			r.r = 0.4
			r.x = bo.tx
			r.y = bo.ty
			table.insert(eripples,r)
		end
		if(bo.timer <= -1) then
			bo.x = bo.tx
			bo.y = bo.ty
			bo.timer = 1
			bo.rippled = false
		end
	elseif(bo.health >= 1) then
		bo.timer = bo.timer - 1 * dt
		bo.angle = math.atan2((player.y - bo.y),(player.x - bo.x))
		dx = math.cos(bo.angle) * 10
		dy = math.sin(bo.angle) * 10		
		if(bo.timer <= 0) then
			spawnE(1)
			spawnE2(1)
			spawnE3(1)
		
			for i=-2,2 do
				b = {}
				b.x = bo.x
				b.y = bo.y
				b.angle = bo.angle
				b.dx = math.cos(b.angle + (0.2 * i)) * 30
				b.dy = math.sin(b.angle + (0.2 * i)) * 30
				table.insert(eBullets,b)
			end
			
			bo.timer = 1
		end
		bo.x = bo.x + dx * dt
		bo.y = bo.y + dy * dt	
	else
		killtimer = killtimer - 1 * dt
		if(killtimer <= 0) then
			r = {}
			r.r = -100
			r.x = bo.x
			r.y = bo.y
			table.insert(eripples,r)
			r = {}
			r.r = -50
			r.x = bo.x
			r.y = bo.y
			table.insert(eripples,r)

			killtimer = 0.2
			killno = killno + 1
		end
		if(killno >= 20) then
			gamestate = "win"
		end
	end 
	
	--bullets collide
	for i,v in ipairs(bullets) do
		if CheckCollision(v.x,v.y,10,10,bo.x * tileSize + cam.x - bo.w/2,bo.y * tileSize + cam.y - bo.h/2,bo.w,bo.h) then
			bo.health = bo.health - 1
			table.remove(bullets,i)
		end
	end
	if(bo.health >= 1) then
	--player collision
		if CheckCollision(player.x * tileSize + cam.x + 5, player.y * tileSize + cam.y + 5,10,10,bo.x * tileSize + cam.x - bo.w/2,bo.y * tileSize + cam.y - bo.h/2,bo.w,bo.h) then
			player.time = 0
		end
	end
end

function boss_draw()
love.graphics.setColor(200,0,0)
	love.graphics.rectangle("fill",bo.x * tileSize + cam.x - bo.w/2,bo.y * tileSize + cam.y - bo.h/2,bo.w,bo.h)
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill",0,0,bo.health/1.5,5)
	love.graphics.setColor(255,255,255)
end