timeOrbs = {}
timeShrines = {}
chests = {}
chestPic = love.graphics.newImage("chest.png")
timeshrinePic = love.graphics.newImage("timeshrine.png")
timeorbPic = love.graphics.newImage("timeorb.png")
potionPic = love.graphics.newImage("potion.png")
speedPic = love.graphics.newImage("speed.png")

function pickups_update(dt)
	for i,v in ipairs(timeOrbs) do
		if CheckCollision(v.x ,v.y,10,10,player.x * tileSize,player.y * tileSize,10,10) then
			player.time = player.time + 2
			table.remove(timeOrbs,i)
			love.audio.play(blip)
		end
		
		v.timer = v.timer - 1 * dt
		if(v.timer <= 0) then
			table.remove(timeOrbs,i)
		end
	end
	for i,v in ipairs(timeShrines) do
		if CheckCollision(v.x * tileSize,v.y * tileSize,50,50,player.x*tileSize,player.y*tileSize,10,10) then
			player.time = 10
			table.remove(timeShrines,i)
			love.audio.play(powerup)
		end
	end
	for i,v in ipairs(chests) do
		if CheckCollision(v.x * tileSize,v.y * tileSize,50,30,player.x*tileSize,player.y*tileSize,10,10) then
			player.time = player.time + v.time
			if(player.time > 10) then
				player.time = 10
				love.audio.play(powerup)
			end
			table.remove(chests,i)
		end
	end
end

function pickups_draw()
	for i,v in ipairs(timeOrbs) do
		--love.graphics.rectangle("fill",v.x + cam.x,v.y + cam.y,5,5)
		love.graphics.draw(timeorbPic,v.x + cam.x,v.y + cam.y)
	end
	for i,v in ipairs(timeShrines) do
		--love.graphics.rectangle("fill",v.x * tileSize + cam.x, v.y * tileSize + cam.y,50,50)
		love.graphics.draw(timeshrinePic,v.x * tileSize + cam.x, v.y * tileSize + cam.y)
	end
	for i,v in ipairs(chests) do
		--love.graphics.rectangle("fill",v.x * tileSize + cam.x, v.y * tileSize + cam.y,50,30)
		love.graphics.draw(chestPic,v.x * tileSize + cam.x, v.y * tileSize + cam.y)
	end
	for i=1,player.potions do
		--love.graphics.rectangle("fill",20 + 20 * (i*0.5),20,10,10)
		love.graphics.draw(potionPic,20 + 20 * (i*0.5),20)
	end
	for i=1,player.speed - 20 do
		--love.graphics.rectangle("fill",20 + 20 * (i*0.5),20,10,10)
		love.graphics.draw(speedPic,20 + 20 * (i*0.5),40)
	end
end