steps = {}
step = 0

laser= {}
firelaser = true

function trap_update(dt)
	for i,v in ipairs(steps) do
		if( step == v.step) then
			if CheckCollision(v.x * tileSize + cam.x, v.y * tileSize + cam.y,50,50,player.x * tileSize + cam.x, player.y * tileSize +cam.y,10,10) then
				table.remove(steps,i)
				player.time = player.time + 2
				step = step + 1
			end
		end
	if(step >= 5) then
		locked = false
	end
	end
	
	for i,v in ipairs(laser) do
		v.x = v.x + 5 * dt * v.d
		if(firelaser == true) then
		if CheckCollision(v.x * tileSize + cam.x + 15,v.y*tileSize+cam.y,10,500,player.x*tileSize+cam.x,player.y*tileSize+cam.y,10,10) then
			firelaser = false
			player.time = player.time - 5
		end
		end
		
		if(v.x > mapW or v.x < 0) then
			table.remove(laser,i)
		end
	end

end

function trap_draw()
	for i,v in ipairs(steps) do
	love.graphics.setColor(255,255,0)
		love.graphics.rectangle("fill",v.x * tileSize + cam.x,v.y * tileSize + cam.y, 50, 50)
		love.graphics.setColor(0,0,0)
		love.graphics.print(v.step,v.x * tileSize + cam.x + 25,v.y * tileSize + cam.y + 25)
		love.graphics.setColor(255,255,255)
	end
	for i,v in ipairs(laser) do

		if(firelaser == true) then
			if(v.y == mapH) then
				--love.graphics.rectangle("fill",v.x * tileSize + cam.x + 25, v.y * tileSize + cam.y,10,-250)
			else
				love.graphics.setColor(200,0,0)
				love.graphics.rectangle("fill",v.x * tileSize + cam.x + 15, v.y * tileSize + cam.y,10,500)
			end
		end
		love.graphics.setColor(100,100,100)
		love.graphics.rectangle("fill",v.x * tileSize + cam.x, v.y * tileSize + cam.y,50,50)
	end
	love.graphics.setColor(255,255,255)
end

function addSteps()
	for i = 1,4 do
		s = {}
		s.x = math.random(5,mapW -5)
		s.y = math.random(4,mapH -5)
		s.step = i
		table.insert(steps,s)
	end
	
	locked = true
	
	step = 1
end

function addlaser()
	firelaser = true
	r = math.random(1,2)
	if(player.x * tileSize < 10) then
		l = {}
		l.x = 1
		l.y = 1
		l.d = 1
		table.insert(laser,l)
		l = {}
		l.x = 1
		l.y = mapH
		l.d = 1
		table.insert(laser,l)
		

	else

		
		l = {}
		l.x = mapW - 1
		l.y = 1
		l.d = -1
		table.insert(laser,l)
		l = {}
		l.x = mapW - 1
		l.y = mapH
		l.d = -1
		table.insert(laser,l)		
	end
	
	
end